package environments

type MigrateOptions struct {

	// Ожидать завершения миграции в синхронном режиме
	Wait bool
}

func MergeMigrateOptions(opts ...*MigrateOptions) *MigrateOptions {
	o := &MigrateOptions{}
	for _, opt := range opts {
		if opt.Wait {
			o.Wait = true
		}
	}
	return o
}

type UpdateOptions struct {

	// Состояние будет обновлено только в том случае, если выполняется указанное условие
	// Cond указывается с использованием синтаксиса `expr`
	Cond string
}

func MergeUpdateOptions(opts ...*UpdateOptions) *UpdateOptions {
	o := &UpdateOptions{}
	for _, opt := range opts {
		if opt.Cond != "" {
			if o.Cond != "" {
				o.Cond += " && "
			}
			o.Cond += opt.Cond
		}
	}
	return o
}
